\documentclass[border=0pt]{standalone}

\usepackage{tikz}
\usepackage{tikz-uml}
\tikzumlset{
	font=\ttfamily,
	fill class=white,
	fill template=white
}

\begin{document}
	\begin{tikzpicture}
		\umlclass[x=3, y=0]{Image}
		{
			+ image : cv::Mat
		}{}

		\umlclass[x=0, y=-5, template=T]{ColorImage}
		{
			+ B : Matrix<T> \\
			+ G : Matrix<T> \\
			+ R : Matrix<T>
		}{}

		\umlclass[x=6, y=-5, template={T,VT}]{ColorImage BC}
		{
			+ Brightness : Matrix<T> \\
			+ Chromaticity : Matrix<VT>
		}{}

		\umlVHVinherit{ColorImage}{Image}
		\umlVHVinherit{ColorImage BC}{Image}

		\umlclass[template=T, x=3, y=-10]{Matrix}
		{
			+ rows : size\_t \\
			+ cols : size\_t \\
			+ values : T[]
		}{}

		\umlassoc[geometry=|-, arg1={}, mult1={1..*}, pos1={0.05}, arg2={B,G,R}, mult2={3}, pos2={0.9}]{ColorImage}{Matrix}
		\umlassoc[geometry=|-, arg1={}, mult1={1..*}, pos1={0.05}, arg2={Bright, Chroma}, mult2={2}, pos2={0.9}]{ColorImage BC}{Matrix}


		\umlclass[template=T, x=12.5, y=-5]{Vec3}
		{
			+ BGR : T[3]
		}{}

		\umlassoc[geometry=--, arg1={uses as VT}, mult1={}, align1=right, pos1={0.01}, arg2={}, mult2={}, pos2={0.85}]{Vec3}{ColorImage BC}
	\end{tikzpicture}
\end{document}
